
#include "shared.h"


/*
    Load a normal file, or ZIP/GZ archive.
    Returns NULL if an error occured.
*/
uint8 /***/load_archive(char *filename, int *file_size,uint8 *buf)
{
    int size = 0;
    unzFile zip_file = 0;    
	char rom_file[256]; //yoyo
	char *p;
	unz_file_info unzinfo;
	char *pext;

    if(check_zip(filename))
    {
    	zip_file = unzOpen(filename);
    	if (!zip_file) 
    	{
    		menu_message("Error while opening zipped file");menu_waitPen(NULL,NULL,1);
    		return 0;
    	}
        unzGoToFirstFile (zip_file);        
        for (;;)
        {
        	if (unzGetCurrentFileInfo(zip_file, &unzinfo, rom_file, sizeof(rom_file), NULL, NULL, NULL, NULL) != UNZ_OK) 
        	{
        		menu_message("Error while getting info from zipped file");menu_waitPen(NULL,NULL,1);
        		return 0;
        	}
       	    p = (char *)strrchr(rom_file, '.');                                
            if (StrCaselessCompare(p, ".smd") == 0) break;
            if (StrCaselessCompare(p, ".bin") == 0) break;               
            if (unzGoToNextFile(zip_file) != UNZ_OK) 
            {
            	menu_message("Error no rom in zipped file");menu_waitPen(NULL,NULL,1);
            	return 0;
            }
         }
         unzOpenCurrentFile (zip_file);

	 	size = unzinfo.uncompressed_size;	 	 	 
		if (!buf)
		{
	    	menu_message("Out of memory");menu_waitPen(NULL,NULL,1);
            unzCloseCurrentFile (zip_file);
	        unzClose (zip_file);    
            return 0;        
		}
	 		 	
		 uint8 *ptmp;
		 ptmp=(uint8*)ljz_malloc(65536);
		 uint32 l=size;
		 uint32 o=0;
		 while (l)
		 {
		 	if (l>65536) 
		 	{
		 		unzReadCurrentFile(zip_file,(void*)(ptmp), 65536);
		 		DmWrite(buf,o,ptmp,65536);
		 		l-=65536;
		 		o+=65536;
		 	}
		 	else		 	
		 	{
		 		unzReadCurrentFile(zip_file,(void*)(ptmp), l);
		 		DmWrite(buf,o,ptmp,l);
		 		l=0;		 		
		 	}
		 }
		 ljz_free(ptmp);
	 	
	 	
        unzCloseCurrentFile (zip_file);
        unzClose (zip_file);    
        /* Update file size and return pointer to file data */
        *file_size = size;

        return 1;//(buf);
    }
    else
    {
        FILE *gd = NULL;
        /* Open file */
        gd = fopen(filename, "rb");
        if(!gd) 
        {
        	menu_message("Error while opening file");menu_waitPen(NULL,NULL,1);
        	return 0;
		}
        /* Get file size */

        fseek(gd,-1,SEEK_END);
        size= ftell(gd)+1;
        fseek(gd,0,SEEK_SET);

        /* Allocate file data buffer */

        if(!buf)
        {
        	menu_message("Out of memory");menu_waitPen(NULL,NULL,1);
            fclose(gd);
            return (0);
        }

        /* Read file data */
        uint8 *ptmp;
		ptmp=(uint8*)ljz_malloc(65536);
		int32 l,FileSize=0;
		while (1)
		{
		 	l=fread (ptmp, 1, 65536, gd);
		 	if (l>=0)
		 	{		 		
			 	DmWrite(buf,FileSize,ptmp,l);
			 	FileSize+=l;
			}
		 	
		 	if (l<65536) break;
		}
		ljz_free(ptmp);	    	    
        

        /* Close file */
        fclose(gd);

        /* Update file size and return pointer to file data */
        *file_size = size;
        return 1;//(buf);
    }
}


/*
    Verifies if a file is a ZIP archive or not.
    Returns: 1= ZIP archive, 0= not a ZIP archive
*/
int check_zip(char *filename)
{
    uint8 buf[2];
    FILE *fd = NULL;
    fd = fopen(filename, "rb");
    if(!fd) return (0);
    fread(buf, 2, 1, fd);
    fclose(fd);
    if(memcmp(buf, "PK", 2) == 0) return (1);
    return (0);
}


