#include "ljz_std.h"

#ifdef LJZ_STD_DEBUG
unsigned int ljz_allocated_ptr[65536];//max 65536 pointers
unsigned int ljz_allocated_size[65536];//max 65536 pointers
unsigned int ljz_num_ptr=0;
#endif



void ljz_std_showstat(void)
{
#ifdef LJZ_STD_DEBUG
	char str[64];
	for (int i=0;i<ljz_num_ptr;i++)
	{
		sprintf(str,"%d %08X %d",i,ljz_allocated_ptr[i],ljz_allocated_size[i]);
		menu_message(str);menu_waitPen(NULL,NULL,1);
//			free(ljz_allocated_ptr[i]);
	}
//	ljz_num_ptr=0;
#endif	
}


void *ljz_malloc(int size)
{
	void *ptr;
	ptr=(void*)malloc(size);
	memset(ptr,0,size);
#ifdef LJZ_STD_ERROR_VERBOSE	
	if (!ptr) {menu_message("Out of memory");menu_waitPen(NULL,NULL,1);}
#endif	
#ifdef LJZ_STD_DEBUG
	if (ptr)
	{
		ljz_allocated_ptr[ljz_num_ptr]=(unsigned int)ptr;		
		ljz_allocated_size[ljz_num_ptr]=size;		
		ljz_num_ptr++;
	}
	else 
	{
		char str[64];
		sprintf(str,"cannot ljz_malloc(%d)",size);
		menu_message(str); menu_waitPen(NULL,NULL,1);
	}
#endif	
	
	return ptr;
}
void *ljz_calloc(int num_elt,int size_elt)
{
	void *ptr;
	ptr=(void*)malloc(num_elt*size_elt);
	if (ptr) memset(ptr,0,num_elt*size_elt);
#ifdef LJZ_STD_ERROR_VERBOSE
	if (!ptr) {menu_message("Out of memory");menu_waitPen(NULL,NULL,1);}
#endif	
#ifdef LJZ_STD_DEBUG
	if (ptr)
	{
		ljz_allocated_ptr[ljz_num_ptr]=(unsigned int)ptr;
		ljz_allocated_size[ljz_num_ptr]=size_elt*num_elt;		
		ljz_num_ptr++;
	}
	else 
	{
		char str[64];
		sprintf(str,"cannot ljz_calloc(%d,%d)",num_elt,size_elt);
		menu_message(str); menu_waitPen(NULL,NULL,1);
	}
#endif		
	
	return ptr;
}
void ljz_free(void *ptr)
{
#ifdef LJZ_STD_DEBUG
	if (ptr)
	{
		for (int i=0;i<ljz_num_ptr;i++)
			if (ljz_allocated_ptr[i]==(unsigned int)ptr) break;
		if (i<ljz_num_ptr)
		{
			for (int j=i;j<(ljz_num_ptr-1);j++)
			{
				ljz_allocated_ptr[j]=ljz_allocated_ptr[j+1];
				ljz_allocated_size[j]=ljz_allocated_size[j+1];
			}
			
			ljz_num_ptr--;
		}
		else
		{
			char str[64];
			sprintf(str,"cannot free(%08X)",(unsigned int)ptr);
			menu_message(str); menu_waitPen(NULL,NULL,1);
		}
	}
#endif	
	if (ptr) free(ptr);		
}


void ljz_cls(TwGfxType *mGfxLib,UInt32 col)
{
	if (mGfxLib)
	{
		TwGfxSurfaceType* displaySurface;
		TwGfxRectType mDispDest;
		TwGfxGetPalmDisplaySurface(mGfxLib, &displaySurface);
		mDispDest.x=0;mDispDest.y=0;
		mDispDest.w=480;mDispDest.h=320;
		TwGfxFillRect(displaySurface,&mDispDest,col);
	}
}