//---------------------------------------------------------------------------
// NEOPOP : Emulator as in Dreamland
//
// Copyright (c) 2001-2002 by neopop_uk
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version. See also the license.txt file for
//	additional informations.
//---------------------------------------------------------------------------

/*
//---------------------------------------------------------------------------
//=========================================================================

	system_main.c

//=========================================================================
//---------------------------------------------------------------------------

  History of changes:
  ===================

//---------------------------------------------------------------------------
*/

#include "neopop.h"
#include <math.h>			//ceil

#include "system_main.h"
#include "system_graphics.h"
#include "system_input.h"
#include "system_sound.h"
#include "system_rom.h"
//#include "system_language.h"
//#include "system_comms.h"


//_u8 system_frameskip_key;
//extern _u8 *bios;

//=============================================================================

char str_month[12][4]=
{"Jan","Feb","Mar","Apr","May","Jun",
"Jul","Aug","Sep","Oct","Nov","Dec"};

char shortrom_filename[64];
char RomPath[256];
char neopopZ_curVolume;

int neopopZ_loadrom();
void neopopZ_end();
int neopopZ_setupenv(TwGfxType* mGfxLib);
void neopopZ_changefskip(void);
void neopopZ_changerendering(void);
void neopopZ_updatevpad(unsigned int val);
void neopopZ_MainLoop(void);
void neopopZ_pause(int pause);
int neopopZ_ShowMenu(void);
void neopopZ_updateScreen(void);
_s32 neopopZ_getTickCount(void);

TwGfxType *neopopZ_mGfxLib;
TwGfxSurfaceType *neopopZ_curRenderingScreen,*neopopZ_RenderingScreen[2];
_u16 *neopopZ_curRenderingScreenPtr,*neopopZ_RenderingScreenPtr[2];
_u32 neopopZ_curRenderingScreenIndex;
_u32 neopopZ_enabledSound,neopopZ_sndfreq;
_u32 neopopZ_renderingmode;
_u32 neopopZ_padState;
_s32 neopopZ_frameskipped,neopopZ_frameskip,neopopZ_fastforward;
_s32 neopopZ_frameBeginTime;
_s32 neopopZ_speedpct;
_s32 neopopZ_autofireA,neopopZ_autofireB;
_s32 neopopZ_framecount,neopopZ_drawframe;
_u32 neopopZ_emu_accuracy;

_s32 neopopZ_frameTime;

TwInputHandle neopopZ_mInputQueue;
long neopopZ_inputFormats[] = { twInputTimeStamp };
typedef struct {long mTime;} neopopZ_ZUserEvent;
neopopZ_ZUserEvent neopopZ_mUserEvent;
long* neopopZ_mInputFormat;        


_u16 *neopopZ_ColorConv;

BOOL paused = FALSE;

//=============================================================================

#define FRAMERATECOUNT	60	//Number of frames between updates.

//=============================================================================

#include "SoundMgr.h"
extern SndStreamRef snd_stream;

char 	savename[255];

void getstate_filename(int num,char *filename)
{
	char result[256];
	_u32 i=0,j=255,k=255,l=255;
	i=0;
	j=255;
	k=-1;
	while (RomPath[i]!=0) 
	{
		if (RomPath[i]=='.') j=i;
		if (RomPath[i]=='/') k=i;
		if (RomPath[i]=='\\') k=i;
		i++;
	  }
	if (j==255) j=i;  //pas d'extension	  
	memcpy(result,RomPath+k+1,j+1-k-1);    
	result[j+1-k-1]=0;
	strcat(result,"ns");
	sprintf(filename,"%s%s%d",NEOPOPZ_SAVESDIR,result,num);
	filename[0]=neopopZ_curVolume+'0';
}

int state_load(int num,int only_test)
{
	FILE	*file;	
	
	
	getstate_filename(num,savename);
	file = fopen(savename, "rb");
	if (file == NULL)
	{
		return -1;
	}
	fclose(file);
	if (only_test) return 0;
	
	
	menu_message("Loading");
	state_restore(savename);	

	return 0;
}

int state_save(int num)
{			
	getstate_filename(num,savename);	
	
	menu_message("Saving");
	
	state_store(savename);	
	return 0;
}


int init_video(void)
{
	//Init vid
	TwGfxSurfaceInfoType surfInfo;
	surfInfo.size = sizeof(surfInfo);
	surfInfo.width = 256; //must be / 4
	surfInfo.height = 256;
	surfInfo.location = twGfxLocationAcceleratorMemoryNoBackingStore;
	surfInfo.pixelFormat = twGfxPixelFormatRGB565;
	xassert(TwGfxAllocSurface(neopopZ_mGfxLib, &neopopZ_RenderingScreen[0], &surfInfo));
	xassert(TwGfxAllocSurface(neopopZ_mGfxLib, &neopopZ_RenderingScreen[1], &surfInfo));

	if (TwGfxLockSurface(neopopZ_RenderingScreen[0], (void**)&neopopZ_RenderingScreenPtr[0]))
	{
	   return 1;
	}
	if (TwGfxLockSurface(neopopZ_RenderingScreen[1], (void**)&neopopZ_RenderingScreenPtr[1]))
	{
	   return 1;
	}
	
	memset(neopopZ_RenderingScreenPtr[0],0,256*256*2);
	memset(neopopZ_RenderingScreenPtr[1],0,256*256*2);
	
	neopopZ_curRenderingScreenIndex=0;
	neopopZ_curRenderingScreen=neopopZ_RenderingScreen[neopopZ_curRenderingScreenIndex];
	neopopZ_curRenderingScreenPtr=neopopZ_RenderingScreenPtr[neopopZ_curRenderingScreenIndex];
					
    /*input*/
    TwInputOpen(&neopopZ_mInputQueue, "twinput", "r");
    neopopZ_mInputFormat = (long*)ljz_malloc(sizeof(long)*sizeof(neopopZ_inputFormats)/sizeof(neopopZ_inputFormats[0]));
    memmove(neopopZ_mInputFormat, neopopZ_inputFormats, sizeof(neopopZ_inputFormats));
    TwInputSetFormat(neopopZ_mInputQueue, neopopZ_mInputFormat, sizeof(neopopZ_inputFormats));    
    TwInputActivate(neopopZ_mInputQueue);
    
    
    neopopZ_ColorConv = (_u16*)ljz_malloc(65536*2);
    int r,g,b;
    for (int i=0;i<65536;i++)
    {    	
    	r = ((i & 0x00F) << 12);
    	g = ((i & 0x0F0) << 3);
		b = ((i & 0xF00) >> 7);
		neopopZ_ColorConv[i]=r|g|b;
	}
	return 0;
}

void neopopZ_initparam(void)
{
	signed long val1,val2,val;
	char *ftrptr;
	FtrGet(APPLI_ID,FTR_OPT_SOUND_ID,(unsigned long*)&val);  
	neopopZ_enabledSound=val;
	FtrGet(APPLI_ID,FTR_OPT_SOUNDFREQ_ID,(unsigned long*)&val);  
	if (val==1) neopopZ_sndfreq=22050;
	else if (val==2) neopopZ_sndfreq=11025;
	else neopopZ_sndfreq=44100;	
	
	FtrGet(APPLI_ID,FTR_OPT_EMU_ACCURACY_ID,(unsigned long*)&val);  
	neopopZ_emu_accuracy=val;
	
	
	FtrGet(APPLI_ID,FTR_OPT_SCREENMODE_ID,(unsigned long*)&val1);
	FtrGet(APPLI_ID,FTR_OPT_SMOOTHING_ID,(unsigned long*)&val2);
		if (!val1) neopopZ_renderingmode=0;
		else 
		if (val1==1) neopopZ_renderingmode=(val2?2:1);
		else
		if (val1==2) neopopZ_renderingmode=(val2?4:3);
		else
	neopopZ_renderingmode=(val2?6:5);	

	neopopZ_fastforward=0;	
	neopopZ_frameskipped=0;
	
    FtrGet(APPLI_ID,FTR_OPT_FSKIP_ID,(unsigned long*)&val); 
	neopopZ_frameskip=val;


//Core settings
	language_english = TRUE;	


	
	
	neopopZ_speedpct=100;
	neopopZ_autofireA=0;
	neopopZ_autofireB=0;	
	neopopZ_framecount=0;
	neopopZ_drawframe=1;
	init_video();	
    

    strcpy(RomPath,NEOPOPZ_ROMSDIR	);
    FtrGet(APPLI_ID,FTR_ROM_FILENAME_ID ,(unsigned long*)&ftrptr);
    
    neopopZ_curVolume=ftrptr[0];
    RomPath[0]=neopopZ_curVolume+'0';
    
    ftrptr+=3;
    strcpy(shortrom_filename,ftrptr);  
    strcat(RomPath,ftrptr);
    FtrPtrFree(APPLI_ID, FTR_ROM_FILENAME_ID);	

    
    neopopZ_frameTime=17; //hardcoded to NTSC
}

void neopopZ_audio_init()
{
	system_sound_init();
}

//extern _u8 *bios;
void neopopZ_initSystem(void)
{     	
     // a ce moment la on lance l'initialisation de l'emulateur
     // 1 - le bios	
//    bios= ljz_malloc(0x10000);   
//menu_confirm("bios install");
//bios=(_u8*)ljz_malloc(0x10000);
    bios_install();     	     
    // 3 - des variables     
    system_colour=COLOURMODE_AUTO;
    // 4 - reset de la machine
//menu_confirm("reset");
    reset();
//menu_confirm("init adr trans tab");
    init_adr_trans_tab();
    if (neopopZ_enabledSound==2) mute=FALSE;
    else mute=TRUE;
    
    
	paused = FALSE;
}
	
int neopopZ_loadrom()
{	
ljz_std_showstat();
	char strload[256];
	neopopZ_initparam();    			
	
	/* Load game */
    sprintf(strload,"Loading : %s",shortrom_filename);
    menu_message(strload);          		
//	unsigned long freeM,maxM;	
//	MemHeapFreeBytes(0,&freeM,&maxM);
//	StrPrintF(strload,"mem : %d %d",freeM,maxM);
//	menu_message(strload);
//	menu_waitPen(NULL,NULL,1);

    rom.data=NULL;    
    if(!system_load_rom(RomPath))
	{
		menu_message("Error loading file");
		menu_waitPen(NULL,NULL,1);
		return 1;
	}	
		
 // la rom est charge. ^_^
 
//menu_confirm("initSystem");
	neopopZ_initSystem();	
//menu_confirm("audio_init");
    neopopZ_audio_init();            

    neopopZ_frameBeginTime=neopopZ_getTickCount();

	neopopZ_pause(0);
    return 0;  
}
void neopopZ_end()
{
	int val;

	TwGfxSurfaceType* displaySurface;
	// Get palmos display surface:
	xassert(TwGfxGetPalmDisplaySurface(neopopZ_mGfxLib, &displaySurface));
	while (TwGfxIsSurfaceReady(displaySurface));	
	

	neopopZ_pause(1);
	
	ljz_free(neopopZ_ColorConv);

	TwGfxUnlockSurface(neopopZ_RenderingScreen[0],0);
	TwGfxUnlockSurface(neopopZ_RenderingScreen[1],0);
	if (neopopZ_RenderingScreen[0]) TwGfxFreeSurface(neopopZ_RenderingScreen[0]);
	if (neopopZ_RenderingScreen[1]) TwGfxFreeSurface(neopopZ_RenderingScreen[1]);  

	TwInputClose(neopopZ_mInputQueue);  	
	ljz_free(neopopZ_mInputFormat);    
/*emu*/

	
	  
/*	  if (saveram) 
	  {
	  	save_sram();
	  	ljz_free(saveram);
	  }*/

	system_unload_rom();
//	ljz_free(bios);
	/********/
      

    FtrSet(APPLI_ID,FTR_OPT_EMU_ACCURACY_ID,neopopZ_emu_accuracy);  
    
 	if ((neopopZ_renderingmode)&&(!(neopopZ_renderingmode&1))) FtrSet(APPLI_ID, FTR_OPT_SMOOTHING_ID,1);
	else FtrSet(APPLI_ID, FTR_OPT_SMOOTHING_ID,0);	

	FtrSet(APPLI_ID, FTR_OPT_SOUND_ID,neopopZ_enabledSound);
	switch (neopopZ_sndfreq)
	{
		case 11025:val=2;break;
		case 22050:val=1;break;
		default:val=0;break;
	}
	FtrSet(APPLI_ID, FTR_OPT_SOUNDFREQ_ID,val);
	
	FtrSet(APPLI_ID, FTR_OPT_SCREENMODE_ID,((neopopZ_renderingmode+1)>>1));
	
	FtrSet(APPLI_ID, FTR_OPT_FSKIP_ID,neopopZ_frameskip);
	
	ljz_std_showstat();

}
int neopopZ_setupenv(TwGfxType* mGfxLib)
{
	neopopZ_mGfxLib=mGfxLib;
	return 0;
}

void neopopZ_MainLoop(void)
{
	if (!neopopZ_enabledSound) emulate_ns(neopopZ_emu_accuracy);
	else emulate(neopopZ_emu_accuracy);
}




_s32 neopopZ_getTickCount(void)
{
	//TODO return tick 
	/*long long l;
	l=TimGetTicks();	
	return l*1000/SysTicksPerSecond();*/	
  	TwInputPoll(neopopZ_mInputQueue, (long *) &neopopZ_mUserEvent, sizeof(neopopZ_mUserEvent));
	return neopopZ_mUserEvent.mTime;
}

void neopopZ_changefskip(void)
{
	char tmp[64];
	int i;
	

	neopopZ_frameskip++;
	if (neopopZ_frameskip>SKEEZIX_FSKIP) neopopZ_frameskip=0;	
	
	if (neopopZ_frameskip==AUTO_FSKIP) sprintf(tmp,"Frameskip : AUTO");
	else if (neopopZ_frameskip==SKEEZIX_FSKIP) sprintf(tmp,"Frameskip : Skeezix");
	else sprintf(tmp,"Frameskip : %d",neopopZ_frameskip);	
	//DrawMessage(tmp,0);
	menu_message(tmp);
	
	i=neopopZ_getTickCount();
	while ((neopopZ_getTickCount()-i)<300)
	{
	}
	neopopZ_frameBeginTime=neopopZ_getTickCount()+neopopZ_frameTime*100/neopopZ_speedpct;
}
void neopopZ_changerendering(void)
{	
	neopopZ_renderingmode++;
	if (neopopZ_renderingmode==7) neopopZ_renderingmode=0;

	menu_message("Changing screen mode");
	neopopZ_frameBeginTime=neopopZ_getTickCount();
	while ((neopopZ_getTickCount()-neopopZ_frameBeginTime)<300)
	{
	}
	neopopZ_frameBeginTime=neopopZ_getTickCount()+neopopZ_frameTime*100/neopopZ_speedpct;
}


void neopopZ_updatevpad(unsigned int val)
{
	neopopZ_padState=val;
}

extern void neopopZ_fastrender(_u16 *src,_u16 *dest,_u16 *colorconv);

void neopopZ_updateScreen(void)
{	 
//	if (neopopZ_drawframe)
	{
		TwGfxPointType destLocation = {0, 0};
	    TwGfxSurfaceType* displaySurface;
		TwGfxRectType mDisp;
		int width = SCREEN_WIDTH;//(reg[12] & 1) ? 320 : 256;
	    int height = SCREEN_HEIGHT;//(reg[1] & 8) ? 240 : 224;
	    
		mDisp.x=0;
		mDisp.y=0;
		mDisp.w=width;
		mDisp.h=height;
    	// Get palmos display surface:
	    xassert(TwGfxGetPalmDisplaySurface(neopopZ_mGfxLib, &displaySurface));	
    
    	//if (width==256) neopopZ_asmfastrender256((_u8*)neopopZ_curRenderingScreenPtr,(_u8*)VideoBuffer,height,bitmap.viewport.x<<1);
    	//if (width==320)	neopopZ_asmfastrender320((_u8*)neopopZ_curRenderingScreenPtr,(_u8*)VideoBuffer,height,bitmap.viewport.x<<1);
    	_u16 *dest=neopopZ_curRenderingScreenPtr;
    	_u16 *src=cfb;
    	neopopZ_fastrender(src,dest,neopopZ_ColorConv);


		switch (neopopZ_renderingmode)
		{    
		case 0:
		{						
			destLocation.x=(480-mDisp.w)>>1;
			destLocation.y=(320-mDisp.h)>>1;
			if (!TwGfxIsSurfaceReady(neopopZ_curRenderingScreen))			
				xassert(TwGfxBitBlt(displaySurface, &destLocation, neopopZ_curRenderingScreen, &mDisp));									
			break;
		}
		case 1:
		{
				TwGfxRectType mDispDest;
				mDispDest.w=width*320/height;
				mDispDest.h=320;				
				mDispDest.x=(480-mDispDest.w)>>1;
				mDispDest.y=0;				
				if (!TwGfxIsSurfaceReady(neopopZ_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, neopopZ_curRenderingScreen, &mDisp,twGfxStretchFast));
				break;
			}
		case 2:
		{
				TwGfxRectType mDispDest;
				mDispDest.w=width*320/height;
				mDispDest.h=320;				
				mDispDest.x=(480-mDispDest.w)>>1;
				mDispDest.y=0;	
				if (!TwGfxIsSurfaceReady(neopopZ_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, neopopZ_curRenderingScreen, &mDisp,twGfxStretchFast|twGfxStretchSmooth));
				break;
			}
			
	
		case 3:
			{
				TwGfxRectType mDispDest;
				mDispDest.x=0;
				mDispDest.y=0;
				mDispDest.w=480;
				mDispDest.h=320;
				if (!TwGfxIsSurfaceReady(neopopZ_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, neopopZ_curRenderingScreen, &mDisp,twGfxStretchFast));
				break;
			}							
		case 4:
			{
				TwGfxRectType mDispDest;
				mDispDest.x=0;
				mDispDest.y=0;
				mDispDest.w=480;
				mDispDest.h=320;
				if (!TwGfxIsSurfaceReady(neopopZ_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, neopopZ_curRenderingScreen, &mDisp,twGfxStretchFast|twGfxStretchSmooth));
				break;
			}							
			
		case 5:
			{
				TwGfxRectType mDispDest;
				mDispDest.x=(480-width*2)>>1;
				mDispDest.y=(320-height*2)>>1;
				mDispDest.w=width*2;
				mDispDest.h=height*2;
				if (!TwGfxIsSurfaceReady(neopopZ_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, neopopZ_curRenderingScreen, &mDisp,twGfxStretchFast));
				break;
			}	
		case 6:
			{
				TwGfxRectType mDispDest;
				mDispDest.x=(480-width*2)>>1;
				mDispDest.y=(320-height*2)>>1;
				mDispDest.w=width*2;
				mDispDest.h=height*2;
				if (!TwGfxIsSurfaceReady(neopopZ_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, neopopZ_curRenderingScreen, &mDisp,twGfxStretchFast|twGfxStretchSmooth));
				break;
			}		
		}
		
//		neopopZ_curRenderingScreenIndex^=1;
//		neopopZ_curRenderingScreenPtr=neopopZ_RenderingScreenPtr[neopopZ_curRenderingScreenIndex];
//		bitmap.data   = (unsigned char *)neopopZ_curRenderingScreenPtr;

	}
	
	//frames_displayed++;	

}


/****************************************************************************/

int neopopZ_ShowMenuGFXConfig(_u8 *savescr)
{
  _u8 *scr;
  int x,y;
  int redraw;  
  int result;
  int scrmode,smoothing,fskipval;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(12*sizeof(RectangleType));
  char tmp[16];
  

	
  if (!neopopZ_renderingmode) {scrmode=0;smoothing=0;}
  else {scrmode=(neopopZ_renderingmode+1)>>1;smoothing=!(neopopZ_renderingmode&1);}
	
  fskipval=neopopZ_frameskip;
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
		
		menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
	  
	  	menu_button(10,80,(char*)"FRAMESKIP",0,&item_rect[1],2);	  
	  	menu_bar(200,80,fskipval,11,&item_rect[2]);
	  	if (fskipval<AUTO_FSKIP) sprintf(tmp,"%d",fskipval);
	  	else if (fskipval==AUTO_FSKIP) sprintf(tmp,"AUTO");
	  	else sprintf(tmp,"Skeezix");
	  	
	  	menu_messageRaw(320,80,tmp);
	  
	  	menu_button(10,130,(char*)"SCREENMODE",0,&item_rect[3],2);
	  	menu_button(200,130,(char*)"1:1",(scrmode==0?2:1),&item_rect[4],0);
	  	menu_button(250,130,(char*)"4:3",(scrmode==1?2:1),&item_rect[5],0);
	  	menu_button(300,130,(char*)"FULL",(scrmode==2?2:1),&item_rect[6],0);
	  	menu_button(350,130,(char*)"ZOOM",(scrmode==3?2:1),&item_rect[7],1);
	  
	  	menu_button(10,180,(char*)"SMOOTHING",0,&item_rect[8],2);
	  	menu_button(200,180,(char*)"OFF",(smoothing?1:2),&item_rect[9],0);
	  	menu_button(250,180,(char*)"ON",(smoothing?2:1),&item_rect[10],0);	  	  	  
	  	
	  	if (scr) WinScreenUnlock();
	
  	  }
	  menu_waitPen(&x,&y,0);
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //FSKIP
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
	  	fskipval=(x-10-item_rect[2].topLeft.x)*11/100;
	  	if (fskipval<0) fskipval=0;
	  	if (fskipval>11) fskipval=11;
	  	redraw=1;
	  }
	  //SCREEN MODES
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
	  	  scrmode=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) 
	  {
	  	  scrmode=1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	  scrmode=2;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	  scrmode=3;
	  	  redraw=1;
	  }
	  //SMOOTHING
	  if (TEST_PEN_MENU(x,y,item_rect[9])&&scrmode) 
	  {
	  	  smoothing=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[10])&&scrmode) 
	  {
	  	  smoothing=1;
	  	  redraw=1;
	  }
  }  
  
  neopopZ_frameskip=fskipval;

  if (!scrmode) neopopZ_renderingmode=0;
	else 
	if (scrmode==1) neopopZ_renderingmode=(smoothing?2:1);
	else
	if (scrmode==2) neopopZ_renderingmode=(smoothing?4:3);
	else
	neopopZ_renderingmode=(smoothing?6:5);
	
  menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}



int neopopZ_ShowMenuSNDConfig(_u8 *savescr)
{
  _u8 *scr;
  int x,y;
  int redraw;  
  int result;
  int vol;
  int bassboost;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  
  vol=TwSndGetVolume();
  bassboost=TwSndGetBassBoost();
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr) memcpy(scr,savescr,480*320*2);	    
//		if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  		
  	  	  	  	  	  	
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"SOUND",0,&item_rect[1],2);
	  menu_button(200,80,(char*)"OFF",(neopopZ_enabledSound==0?2:1),&item_rect[2],0);
	  menu_button(250,80,(char*)"SIM",(neopopZ_enabledSound==1?2:1),&item_rect[3],0);	  
	  menu_button(300,80,(char*)"ON",(neopopZ_enabledSound==2?2:1),&item_rect[4],0);	 
	  
/*	  menu_button(10,120,(char*)"VOLUME",0,&item_rect[5],2);	  
	  menu_bar(200,120,vol,64,&item_rect[6]);
	  sprintf(tmp,"%d%",vol*100/64);	  	
	  	menu_messageRaw(320,120,tmp);*/
	  
	  menu_button(10,160,(char*)"BASS BOOST",0,&item_rect[7],2);
	  menu_button(200,160,(char*)"OFF",(bassboost==0?2:1),&item_rect[8],0);
	  menu_button(300,160,(char*)"ON",(bassboost?2:1),&item_rect[9],0);	 
		if (scr) WinScreenUnlock();	  
  	  }
	  menu_waitPen(&x,&y,0);
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //SOUND OFF / z80 off
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  neopopZ_enabledSound=0;
		  mute = TRUE;
		  redraw=1;
	  }
	  //SOUND OFF / z80 on
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
	  	  if (!neopopZ_enabledSound) 
	  	  {
	  	  	if (menu_confirm("RESET needed. Continue ?"))
	  	  	{
	  	  		neopopZ_enabledSound=1;
	  	  		mute = TRUE;
	  	  		reset();
	  	  	}
	  	  }
	  	  else
	  	  {
		  	    neopopZ_enabledSound=1;
	  			mute = TRUE;
	  	  }
	  	  redraw=1;
	  }
	  //SOUND ON / z80 on
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
	  	  if (!neopopZ_enabledSound)
	  	  {
	  	  	if (menu_confirm("RESET needed. Continue ?"))
	  	  	{
	  	  		neopopZ_enabledSound=2;
	  	  		mute = FALSE;
	  	  		reset();
	  	  	}
	  	  }
	  	  else
	  	  {
			  neopopZ_enabledSound=2;
			  mute = FALSE;
		  }
		  redraw=1;
	  }
	  
	  //VOLUME
/*	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	vol=(x-item_rect[6].topLeft.x)*64/100;
	  	if (vol>64) vol=64;
	  	redraw=1;
	  }*/
	  //BASSBOOST OFF
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	bassboost=0;
	  	redraw=1;
	  }
	  //BASSBOOST ON
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	bassboost=1;
	  	redraw=1;
	  }
  }  
  
  TwSndSetVolume(vol);
  TwSndSetBassBoost(bassboost);
  
  menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}


int neopopZ_ShowMenuOTHERConfig(_u8 *savescr)
{
  _u8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(20*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr) memcpy(scr,savescr,480*320*2);	    
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  		
  	  	  	  	  	  	
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"AUTOFIRE A",0,&item_rect[1],2);
	  menu_button(200,80,(char*)"OFF",(neopopZ_autofireA==0?2:1),&item_rect[2],0);
	  menu_button(250,80,(char*)"SLW",(neopopZ_autofireA==1?2:1),&item_rect[3],0);
	  menu_button(300,80,(char*)"MED",(neopopZ_autofireA==2?2:1),&item_rect[4],0);
	  menu_button(350,80,(char*)"FST",(neopopZ_autofireA==3?2:1),&item_rect[5],0);
	  
	  menu_button(10,120,(char*)"AUTOFIRE B",0,&item_rect[6],2);
	  menu_button(200,120,(char*)"OFF",(neopopZ_autofireB==0?2:1),&item_rect[7],0);
	  menu_button(250,120,(char*)"SLW",(neopopZ_autofireB==1?2:1),&item_rect[8],0);
	  menu_button(300,120,(char*)"MED",(neopopZ_autofireB==2?2:1),&item_rect[9],0);
	  menu_button(350,120,(char*)"FST",(neopopZ_autofireB==3?2:1),&item_rect[10],0);	  	  
	  
	  
	  menu_button(10,160,(char*)"EMU SPEED",0,&item_rect[11],2);	  
	  menu_bar(200,160,neopopZ_speedpct,100,&item_rect[12]);
	  sprintf(tmp,"%d%",neopopZ_speedpct);
      menu_messageRaw(320,160,tmp);
      
      menu_button(10,200,(char*)"EMU ACCUR.",0,&item_rect[13],2);
	  menu_button(200,200,(char*)"CMP",(neopopZ_emu_accuracy==0?2:1),&item_rect[14],0);
	  menu_button(250,200,(char*)"MED",(neopopZ_emu_accuracy==1?2:1),&item_rect[15],0);
	  menu_button(300,200,(char*)"FST",(neopopZ_emu_accuracy==2?2:1),&item_rect[16],0);
      
      
	  
		if (scr) WinScreenUnlock();	  
  	  }
	  menu_waitPen(&x,&y,0);
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //AUTOFIRE A
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  neopopZ_autofireA=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  neopopZ_autofireA=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  neopopZ_autofireA=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) 
	  {
		  neopopZ_autofireA=3;
		  redraw=1;
	  }
	  //AUTOFIRE B
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
		  neopopZ_autofireB=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
		  neopopZ_autofireB=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
		  neopopZ_autofireB=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[10])) 
	  {
		  neopopZ_autofireB=3;
		  redraw=1;
	  }
	  //SPEED
	  if (TEST_PEN_MENU(x,y,item_rect[12])) 
	  {
	  	neopopZ_speedpct=(x-10-item_rect[12].topLeft.x);
	  	if (neopopZ_speedpct>100) neopopZ_speedpct=100;
	  	if (neopopZ_speedpct<10) neopopZ_speedpct=10;
	  	redraw=1;
	  }
	  
	  //EMU ACCURACY
	  if (TEST_PEN_MENU(x,y,item_rect[14])) 
	  {
		  neopopZ_emu_accuracy=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[15])) 
	  {
		  neopopZ_emu_accuracy=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[16])) 
	  {
		  neopopZ_emu_accuracy=2;
		  redraw=1;
	  }
  }  
  
  menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}


int neopopZ_ShowMenuConfig(_u8 *savescr)
{
  _u8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  		
  	  	  	  	  	  	
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(172,100,(char*)"GFX",0,&item_rect[1],2);
	  menu_button(172,150,(char*)"SOUND",0,&item_rect[2],2);
	  menu_button(172,200,(char*)"OTHER",0,&item_rect[3],2);
	  menu_button(172,250,(char*)"SND & BRT",9,&item_rect[4],2);
	  if (scr) WinScreenUnlock();
  	  }
	  menu_waitPen(&x,&y,1);
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //GFX
	  if (TEST_PEN_MENU(x,y,item_rect[1])) 
	  {
	  	neopopZ_ShowMenuGFXConfig(savescr);
		redraw=1;
	  }
	  //SOUND
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
     	neopopZ_ShowMenuSNDConfig(savescr);
		redraw=1;
	  }
	  //OTHER
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  neopopZ_ShowMenuOTHERConfig(savescr);
		  redraw=1;		  
	  }
	  //SND & BRT
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
	  	  EventType myevent;
	  	  
	  	  for (;;)	  	  
	  	  {
		  	  EvtGetEvent(&myevent,0);
	  	  	  if (myevent.eType==nilEvent) break;			  
		  }
	  	  
	  	  myevent.eType=keyDownEvent;
	  	  myevent.data.keyDown.chr=vchrBrightness;	  	  
	  	  EvtAddEventToQueue(&myevent);
	  	  
	  	  for (;;)	  	  
	  	  {
		  	  EvtGetEvent(&myevent,100);
	  	  	  if (myevent.eType==nilEvent) break;
			  if (myevent.eType==keyDownEvent)
			  {
			  	if (myevent.data.keyDown.chr!=vchrLaunch)
			  	{SysHandleEvent(&myevent);}
			  }			  
		  }
		  redraw=1;
	  }
  }  
  ljz_free(item_rect);
  return result;
}



int neopopZ_ShowMenuSave(_u8 *savescr)
{
  _u8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
   int slot[4];
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  		
  	  	  	  	  	  	
	  FILE *savefile;
  	 
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
  	  for (int i=0;i<4;i++) 
  	  	if (!state_load(i,1)) 
  	  	{
      		slot[i]=1;
      
	  		struct tm *localTime;
			time_t long_time;
			char str[255];		
			getstate_filename(i,str);
			long_time=__getdate_file(str);		
			localTime = localtime(&long_time);
			
			//date is an ofs from 01 Jan 1900 00:00:00			
			sprintf(str,"%02d %s %02d %02d:%02d",
			localTime->tm_mday,str_month[localTime->tm_mon],localTime->tm_year-100,localTime->tm_hour,localTime->tm_min);
			if (i) 
			{
				menu_messageRaw(300,50+i*30,str);
				menu_button(160,50+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(300,170,str);
				menu_button(160,170,"X",5,&item_rect[6+i],3);
			}

	  	}	  	  	
  	  	  	  	  	  	
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
	  menu_button(10,80,(char*)"SAVE",0,&item_rect[1],2);
	  menu_button(200,80,(char*)"SLOT 1",(slot[1]?2:1),&item_rect[2],1);
	  menu_button(200,110,(char*)"SLOT 2",(slot[2]?2:1),&item_rect[3],1);
	  menu_button(200,140,(char*)"SLOT 3",(slot[3]?2:1),&item_rect[4],1);
	  menu_button(200,170,(char*)"QUICK",(slot[0]?2:1),&item_rect[5],1);
	  if (scr) WinScreenUnlock();
  	  }
	  menu_waitPen(&x,&y,1);
	  
	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			getstate_filename(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			getstate_filename(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			getstate_filename(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			getstate_filename(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //SAVE 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
	  	  if (!slot[1]||(menu_confirm("Overwrite ?")))
		  {state_save(1);result=1;break;}
		  else redraw=1;
		  
	  }
	  //SAVE 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (!slot[2]||(menu_confirm("Overwrite ?")))
		  {state_save(2);result=1;break;}
		  else redraw=1;
		
	  }
	  //SAVE 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
    	  if (!slot[3]||(menu_confirm("Overwrite ?")))
		  {state_save(3);result=1;break;}
		  else redraw=1;
		
	  }
	  //QUICKSAVE
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
	  	  if (!slot[0]||(menu_confirm("Overwrite ?")))
		  {state_save(0);result=1;break;}
		  else redraw=1;
		
	  }
  }  
  ljz_free(item_rect);
  return result;
}



int neopopZ_ShowMenuLoad(_u8 *savescr)
{
  _u8 *scr;
  int x,y;
  int redraw;  
  int result;
   int slot[4];
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
//		if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  	  FILE *savefile;
  	 
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
      for (int i=0;i<4;i++) 
      	if (!state_load(i,1))
      		{
      		slot[i]=1;
      
	  		struct tm *localTime;
			time_t long_time;
			char str[255];		
			getstate_filename(i,str);
			long_time=__getdate_file(str);		
			localTime = localtime(&long_time);			
			//date is an ofs from 01 Jan 1900 00:00:00
			sprintf(str,"%02d %s %02d %02d:%02d",
			localTime->tm_mday,str_month[localTime->tm_mon],localTime->tm_year-100,localTime->tm_hour,localTime->tm_min);
			if (i) 
			{
				menu_messageRaw(300,50+i*30,str);
				menu_button(160,50+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(300,170,str);
				menu_button(160,170,"X",5,&item_rect[6+i],3);
			}
	  	}	  	  	
      
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
	  menu_button(10,80,(char*)"LOAD",0,&item_rect[1],2);
	  menu_button(200,80,(char*)"SLOT 1",(slot[1]?2:3),&item_rect[2],1);
	  menu_button(200,110,(char*)"SLOT 2",(slot[2]?2:3),&item_rect[3],1);
	  menu_button(200,140,(char*)"SLOT 3",(slot[3]?2:3),&item_rect[4],1);
	  menu_button(200,170,(char*)"QUICK",(slot[0]?2:3),&item_rect[5],1);
		if (scr) WinScreenUnlock();	  
  	  }
	  menu_waitPen(&x,&y,1);
	  
	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			getstate_filename(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			getstate_filename(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			getstate_filename(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			getstate_filename(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //LOAD 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  if (slot[1])
		if (!state_load(1,0)) {result=1;break;}
	  }
	  //LOAD 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (slot[2])
		if (!state_load(2,0)) {result=1;break;}
	  }
	  //LOAD 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (slot[3])
		if (!state_load(3,0)) {result=1;break;}	  
	  }
	
	  //QUICKLOAD
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
	  	if (slot[0])
    	if (!state_load(0,0)) {result=1;break;}
	  }
  }  
  ljz_free(item_rect);
  return result;
}


int neopopZ_ShowSysInfos(_u8 *savescr)
{
  _u8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect,my_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
				
		char str[64],strb[32];
		unsigned long maxP,freeP,usedP;		
		VolumeInfoType vinfo;
		VFSVolumeSize(neopopZ_curVolume,&usedP,&maxP);		
		VFSVolumeGetLabel(neopopZ_curVolume,strb,16);strb[16]=0;
		menu_button(10,70,"Volume",0,&my_rect,4);		
		sprintf(str,"%s[%d] Used:%dMb/%dMb",strb,neopopZ_curVolume,usedP>>20,maxP>>20);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,70,str);				
		MemHeapFreeBytes(0,&freeP,&maxP);		
		menu_button(10,100,"RAM",6,&my_rect,4);		
		sprintf(str,"RAM Free:%d Max:%d",freeP,maxP);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,100,str);		
		TwGfxInfoType gfxinfo;
		gfxinfo.size=sizeof(gfxinfo);
		TwGfxGetInfo(neopopZ_mGfxLib,&gfxinfo);		
		menu_button(10,130,"VRAM",6,&my_rect,4);		
		sprintf(str,"Free:%d Max:%d",gfxinfo.freeAcceleratorMemory,gfxinfo.totalAcceleratorMemory);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,130,str);
						
    		
/*		menu_button(10,160,"ROM",4,&my_rect,4);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,160,rom.name);
		
		sprintf(str,"%dKo RAM-%dKo",mbc.romsize,mbc.ramsize);
		menu_button(10,190,"Size",4,&my_rect,4);
	    menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,190,str);
	    
		menu_button(10,220,"Type",7,&my_rect,4);		
		sprintf(str,"%d Batt:%d Rtc:%d CGB:%d",mbc.type,mbc.batt,rtc.batt,hw.cgb);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,220,str);*/
		
						  	
	  	menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
		
	  
	  	if (scr) WinScreenUnlock();
  	  }
	  menu_waitPen(&x,&y,1);
	  
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  
	  
  }  
  ljz_free(item_rect);
  return result;
}



int neopopZ_ShowMenu()
{
  int x,y;
  int redraw;
  int result;
  int slot0;
  _u8 *scr,*savescr;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));  
  redraw=1;
  
  neopopZ_pause(1);
    
  
  TwGfxSurfaceType* displaySurface;
  // Get palmos display surface:
  xassert(TwGfxGetPalmDisplaySurface(neopopZ_mGfxLib, &displaySurface));
  while (TwGfxIsSurfaceReady(displaySurface));

  
  savescr=(_u8*)ljz_malloc(320*480*2);  
  scr=WinScreenLock(winLockCopy);  
  if (scr&&savescr)
  {
	  for (x=0;x<320*480;x++)
	  {
  		y=((_u16*)scr)[x];
	  	((_u16*)scr)[x]=((y>>12)<<11)|(((y>>6)&31)<<5)|((y>>1)&15);
	  }
	  memcpy(savescr,scr,480*320*2);
  }
  if (scr) WinScreenUnlock();
            
              
  for (;;)
  {  
  	if (redraw)
  	{  	
	  	slot0=!state_load(0,1);    
  		redraw=0;
		scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
//		if (scr) WinScreenUnlock();
  		
  		RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  		
		menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
		menu_button(60,100,(char*)"SAVE",0,&item_rect[1],2);
		menu_button(280,100,(char*)"QUICK SAVE",(slot0?2:1),&item_rect[2],2);
		menu_button(60,150,(char*)"LOAD",0,&item_rect[3],2);
		menu_button(280,150,(char*)"QUICK LOAD",(slot0?2:3),&item_rect[4],2);
		menu_button(60,200,(char*)"CONFIG",0,&item_rect[5],2);
		menu_button(280,250,(char*)"LAUNCHER",4,&item_rect[6],2);
		
		menu_button(280,200,(char*)"SYS INFOS",7,&item_rect[8],2);
		
		menu_button(60,250,(char*)"RESET NGP",9,&item_rect[7],2);				
		if (scr) WinScreenUnlock();		
		
  	}
	  menu_waitPen(&x,&y,1);
	  //HOME
	  if (TEST_PEN_MENU(x,y,item_rect[6])) {result=1;break;}
	  //BACK
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //CONFIG
	  if (TEST_PEN_MENU(x,y,item_rect[5])) {neopopZ_ShowMenuConfig(savescr);redraw=1;}
	  //LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[3])) {if (neopopZ_ShowMenuLoad(savescr)) {result=0;break;} redraw=1;}
	  //SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[1])) {if (neopopZ_ShowMenuSave(savescr)) {result=0;break;} redraw=1;}
	  //QUICK SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  state_save(0);
		  result=0;
		  break;
	  }
	  //QUICK LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (slot0)
		    if (!state_load(0,0)) {result=0;break;}
	  }
	  //RESET NGP
	  if (TEST_PEN_MENU(x,y,item_rect[7])) {if (menu_confirm("RESET NGP ?")) {reset(); result=0;break;}redraw=1;}
	  //SYS INFOS
	  if (TEST_PEN_MENU(x,y,item_rect[8])) {neopopZ_ShowSysInfos(savescr);redraw=1;}

	}
  ljz_free(item_rect);
  
  ljz_free(savescr);
            
  neopopZ_pause(0);
  return result;
}  





//-----------------------------------------------------------------------------
// system_message()
//-----------------------------------------------------------------------------
void __cdecl system_message(char* vaMessage,...)
{
	char message[1001];
    va_list vl;

    va_start(vl, vaMessage);
    vsprintf(message, vaMessage, vl);
	va_end(vl);

/*	if (windowed)
		MessageBox(GetDesktopWindow(), message, PROGRAM_NAME, MB_OK | MB_ICONINFORMATION);*/
	menu_message(message);
//	menu_waitPen(NULL,NULL,1);
}

//=============================================================================

//-----------------------------------------------------------------------------
// windows_load_rom()
//-----------------------------------------------------------------------------
static BOOL windows_load_rom(char* filename)
{
	if (system_load_rom(filename))	//Load the rom
	{
		//Add to MRU

		reset();
		return TRUE;
	}

	return FALSE;
}



//-----------------------------------------------------------------------------
// system_VBL()
//-----------------------------------------------------------------------------

void system_VBL(void)
{
	neopopZ_framecount++;
	//Throttle speed
	int haswaited;
	neopopZ_frameBeginTime+=neopopZ_frameTime*100/neopopZ_speedpct;	//60Hz
			
	//Frameskip
	if ((neopopZ_frameskip==AUTO_FSKIP)&&(!neopopZ_fastforward))
	{
		
		//do avoid issue when Tick is looping
		if ((_s32)(neopopZ_frameBeginTime-neopopZ_getTickCount())>=(_s32)(20*neopopZ_frameTime))	
			neopopZ_frameBeginTime=neopopZ_getTickCount()+neopopZ_frameTime*100/neopopZ_speedpct;				
		//while (neopopZ_getTickCount()<=neopopZ_frameBeginTime)  haswaited=1;		
		int i=neopopZ_frameBeginTime-neopopZ_getTickCount()+1;
        if (i>0) {haswaited=1; SysTaskDelay(i);}

	
		if (haswaited) 
		{
			neopopZ_frameskipped=0;
			neopopZ_drawframe=1;
		}
		else 
		{
			neopopZ_frameskipped++;
			if (neopopZ_frameskipped>MAX_FRAME_SKIPPED) 
			{
				neopopZ_frameskipped=0;
				neopopZ_drawframe=1;
			}
			else neopopZ_drawframe=0;
		}			
	}
	else
	{
		if (neopopZ_frameskip==SKEEZIX_FSKIP) neopopZ_frameskipped=SKEEZIX_FSKIP;
		neopopZ_frameskipped++;
		if (neopopZ_fastforward)
		{
			if (neopopZ_frameskipped>NEOPOPZ_TURBOFSKIP)
			{
				neopopZ_frameskipped=0;
				neopopZ_drawframe=1;
			}
			else neopopZ_drawframe=0;
		}
		else
		{
			if (neopopZ_frameskipped>neopopZ_frameskip)
			{
				neopopZ_frameskipped=0;
				neopopZ_drawframe=1;
			}
			else neopopZ_drawframe=0;
		}

		if ((!neopopZ_fastforward)&&(neopopZ_drawframe||(neopopZ_enabledSound==2)))
		{
			//do avoid issue when Tick is looping
			if ((_s32)(neopopZ_frameBeginTime-neopopZ_getTickCount())>=(_s32)(20*neopopZ_frameTime))	
				neopopZ_frameBeginTime=neopopZ_getTickCount()+neopopZ_frameTime*100/neopopZ_speedpct;				
			//while (neopopZ_getTickCount()<=neopopZ_frameBeginTime) ;
			int i=neopopZ_frameBeginTime-neopopZ_getTickCount()+1;
	        if (i>0) {SysTaskDelay(i);}
		}
	}
	
	if (neopopZ_drawframe)	// Update Graphics
		neopopZ_updateScreen();

	system_input_update();	
}
