//////////////////////////////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//////////////////////////////////////////////////////////////////////////////

#include "zlib.h"

#include <TapWave.h>
//#undef OF
using namespace std;

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <malloc.h>
//#include <io.h>
#include <fcntl.h>
#include "types.h"
#include "log.h"
#include "rom.h"

#include "ljz_std.h"


#include "unzip.h"
//#undef OF


extern int ws_system;

uint8 *LoadRomFile(char* filename,uint32 *RomSize)
{
	FILE *f;
	uint8 *rom;
	f=fopen(filename,"rb");
	if (!f) return NULL;
	fseek(f,-1,SEEK_END);	
	*RomSize = ftell(f)+1;//statbuffer.st_size;
	rom = (uint8*)ljz_malloc(*RomSize);	
	fseek(f,0,SEEK_SET);
	fread(rom,*RomSize,1,f);	
	fclose(f);
	
	int i=strlen(filename);
	if ((filename[i-1]=='c')||(filename[i-1]=='C')) ws_system=WS_SYSTEM_COLOR;	
	else ws_system=WS_SYSTEM_MONO;
	
	return rom;
}

//=============================================================================


uint8 *LoadRomZip(char* filename,uint32 *RomSize)
{
	uint8 *rom;
	unzFile zip = NULL;
	char currentZipFileName[256];
	unz_file_info fileInfo;

	if ((zip = unzOpen(filename)) == NULL)
	{
//		system_message("%s\n%s", "cannot find zip entry ", filename);
		return NULL;
	}

	//Scan for the file list
	if (unzGoToFirstFile(zip) != UNZ_OK)
	{
		unzClose(zip);
//		system_message("%s\n%s", "bad zip", filename);
		return NULL;
	}
		
	while (unzGetCurrentFileInfo(zip, &fileInfo, currentZipFileName, 
			256, NULL, 0, NULL, 0) == UNZ_OK)
	{
		StrToLower(currentZipFileName,currentZipFileName);
		

		//Find a rom with the correct extension
		if (strstr(currentZipFileName, ".ws") == NULL &&
			strstr(currentZipFileName, ".wsc") == NULL )
		{
			//Last one?
			if (unzGoToNextFile(zip) == UNZ_END_OF_LIST_OF_FILE)
				break;
			else
				continue;	//Try the next...
		}

		//Extract It
		*RomSize = fileInfo.uncompressed_size;

		//Open the file
		if(unzOpenCurrentFile(zip) == UNZ_OK)
		{
			int i=strlen(currentZipFileName);
			if ((currentZipFileName[i-1]=='c')||(currentZipFileName[i-1]=='C')) ws_system=WS_SYSTEM_COLOR;	
			else ws_system=WS_SYSTEM_MONO;
		
			*RomSize = fileInfo.uncompressed_size;

			//Reserve the space required
			rom = (uint8*)ljz_malloc(*RomSize);
									
			//Read the File
			if(unzReadCurrentFile(zip, rom, *RomSize) >= 0)
			{
				//Load complete
				unzCloseCurrentFile(zip);
				unzClose(zip);
				return rom;	//success!
			}
			else
			{
//				system_message("%s\n%s", "bad zip", filename);
				unzCloseCurrentFile(zip);
				unzClose(zip);
				ljz_free(rom);
				return NULL;
			}
		}
		else
		{
//			system_message("%s\n%s", "bad zip", filename);
			unzClose(zip);
			return NULL;
		}
	}

	unzClose(zip);
//	system_message("%s\n%s", "no file in zip", filename);
	return NULL;
}


////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
uint8	*ws_rom_load(char *path, uint32 *romSize)
{
	/*uint8	*rom=NULL;
	uint32 filepos;
	FILE *fp=fopen(path,"rb");
	if (fp==NULL)
		return(NULL);

	fseek(fp,-1,SEEK_END);
	filepos=ftell(fp)+1;
	*romSize=filepos;
	fseek(fp,0,SEEK_SET);
	rom=(uint8*)ljz_malloc(*romSize);
	fread(rom,*romSize,1,fp);
	fclose(fp);	
	return(rom);*/
	uint8 *rom=NULL;
	char copyFNAME[256];
	int i;
	
	//Load the file

	strcpy(copyFNAME, path);
	StrToLower(copyFNAME,copyFNAME);
	if (strstr(copyFNAME, ".zip"))
		rom = LoadRomZip(path,romSize);		// Load Zip
	else
		rom = LoadRomFile(path,romSize);	// Load raw file
	
	return rom;
}
////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
void	ws_rom_dumpInfo(uint8 *wsrom, uint32 romSize)
{
	ws_romHeaderStruct		*romHeader=ws_rom_getHeader(wsrom,romSize);

/*	fprintf(log_get(),"rom: developper Id  0x%.2x\n",romHeader->developperId);
	fprintf(log_get(),"rom: cart Id        0x%.2x\n",romHeader->cartId);
	fprintf(log_get(),"rom: minimum system %s\n",(romHeader->minimumSupportSystem==WS_SYSTEM_MONO)?"Wonderswan mono":"Wonderswan color");
	fprintf(log_get(),"rom: size           %i Mbits\n",(romSize>>20)<<3);
	fprintf(log_get(),"rom: eeprom         ");
	switch (romHeader->eepromSize&0xf)
	{
	case WS_EEPROM_SIZE_NONE:	{ fprintf(log_get(),"none\n"); break; }
	case WS_EEPROM_SIZE_64k:	{ fprintf(log_get(),"64 kb\n"); break; }
	case WS_EEPROM_SIZE_256k:	{ fprintf(log_get(),"256 kb\n"); break; }
	}
	fprintf(log_get(),"rom: sram           ");
	switch (romHeader->eepromSize&0xf0)
	{
	case WS_SRAM_SIZE_NONE:	{ fprintf(log_get(),"none\n"); break; }
	case WS_SRAM_SIZE_1k:	{ fprintf(log_get(),"1 kb\n"); break; }
	case WS_SRAM_SIZE_16k:	{ fprintf(log_get(),"16 kb\n"); break; }
	case WS_SRAM_SIZE_8k:	{ fprintf(log_get(),"8 kn\n"); break; }
	}
	
	fprintf(log_get(),"rom: rtc            %s\n",(romHeader->realtimeClock)?"Yes":"None");
	fprintf(log_get(),"checksum            0x%.4x\n",romHeader->checksum);*/

	ljz_free(romHeader);
}

////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
ws_romHeaderStruct		*ws_rom_getHeader(uint8 *wsrom, uint32 wsromSize)
{
	ws_romHeaderStruct *wsromHeader=(ws_romHeaderStruct *)ljz_malloc(sizeof(ws_romHeaderStruct));

	memcpy(wsromHeader,wsrom+(wsromSize-10),10);
	return(wsromHeader);
}
////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
uint32				ws_rom_sramSize(uint8 *wsrom, uint32 wsromSize)
{
	ws_romHeaderStruct		*romHeader=ws_rom_getHeader(wsrom,wsromSize);
	switch (romHeader->eepromSize&0xf0)
	{
	case WS_SRAM_SIZE_NONE:		ljz_free(romHeader);return(0);
	case WS_SRAM_SIZE_1k:		ljz_free(romHeader);return(0x400);
	case WS_SRAM_SIZE_16k:		ljz_free(romHeader);return(0x4000);
	case WS_SRAM_SIZE_8k:		ljz_free(romHeader);return(0x2000);
	}
	
	ljz_free(romHeader);
	return(0);
}
////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
uint32				ws_rom_eepromSize(uint8 *wsrom, uint32 wsromSize)
{
	ws_romHeaderStruct		*romHeader=ws_rom_getHeader(wsrom,wsromSize);
	switch (romHeader->eepromSize&0xf)
	{
	case WS_EEPROM_SIZE_NONE:	ljz_free(romHeader);return(0);
	case WS_EEPROM_SIZE_64k:	ljz_free(romHeader);return(0x10000);
	case WS_EEPROM_SIZE_256k:	ljz_free(romHeader);return(0x40000);
	}
	
	ljz_free(romHeader);
	return(0);
}

