/*
	File:			Application.cpp	

	Description:	Contains the 68K portion of the Palm ARMlet.  It sets up a form so that
					the UI works with the Palm UI, and it calls the ARMlet.

	Author:		

	Copyright:		Copyright  2003 by Tapwave, Inc.

	Disclaimer:		IMPORTANT:  This Tapwave software is provided by Tapwave, Inc. ("Tapwave").  Your 
					use is subject to and governed by terms and conditions of the Software Development 
					Kit Agreement ("SDK Agreement") between you and Tapwave.  If you have not entered 
					into Tapwaves standard SDK Agreement with Tapwave, you have no right or license 
					to use, reproduce, modify, distribute or otherwise exploit this Tapwave software.  
					You may obtain a copy of Tapwaves standard SDK Agreement by calling 650-960-1817
					or visiting Tapwave at http://www.tapwave.com/developers/. 

	Change History (most recent first):
				
*/

#ifndef __App_Cst_h__
#define __App_Cst_h__


#define __NES_ROMS_DIR__ "/PALM/Programs/LJZ/NES/Roms/"
#define __SNES_ROMS_DIR__ "/PALM/Programs/LJZ/SNES/Roms/"
#define __GB_ROMS_DIR__ "/PALM/Programs/LJZ/GB/Roms/"
#define __GENZ_ROMS_DIR__ "/PALM/Programs/LJZ/GENZ/Roms/"
#define __NEOPOPZ_ROMS_DIR__ "/PALM/Programs/LJZ/NGP/Roms/"
#define __OSWANZ_ROMS_DIR__ "/PALM/Programs/LJZ/WS/Roms/"
#define __TG16Z_ROMS_DIR__ "/PALM/Programs/LJZ/TG16/Roms/"

#define WELCOME_MESSAGE "Welcome to LJZ 0.7"

#define FORM_LISTROM_ID 5000

#define FTR_ROM_FILENAME_ID 6000
#define FTR_ROM_ID 6001 //for loading rom in ftr mem
#define FTR_OPT_SMOOTHING_ID 6002
#define FTR_OPT_SCREENMODE_ID 6003
#define FTR_OPT_FSKIP_ID 6004
#define FTR_OPT_CPUCORE_ID 6005
#define FTR_OPT_EMU_ACCURACY_ID 6006
#define FTR_OPT_SOUND_ID 6010
#define FTR_OPT_SOUNDFREQ_ID 6011

#define FTR_OPT_SNESRENDER_ID 6020
#define FTR_OPT_SNESTRANSP_ID 6021
#define FTR_OPT_FAST_SPR_ID 6022

#define FTR_OPT_INPUTCONF_ID 6030

#define SYS_NES     1
#define SYS_SNES    2
#define SYS_GB      4
#define SYS_GENZ    8
#define SYS_NEOPOPZ 16
#define SYS_OSWANZ  32
#define SYS_TG16Z   64

#define APPLI_ID 'LJZZ'

#define VERSION 0x0060


#define BTN_Red		0x01
#define BTN_Green	0x02
#define BTN_Yellow	0x03
#define BTN_Blue	0x04
#define BTN_L		0x05
#define BTN_R		0x06
#define BTN_Func	0x07
#define BTN_Home	0x08
#define BTN_Up		0x09
#define BTN_Down	0x0A
#define BTN_Left	0x0B
#define BTN_Right	0x0C
#define BTN_TL		0x0D
#define BTN_BL		0x0E
#define BTN_TR		0x0F
#define BTN_BR		0x10
#define BTN_Anal	0x11





#endif
